/* We gonna hook Mario's debug menu
 * use it to load our "real" code from ROM
 * to extended RAM and jump to it.
*/
.org 0x861C0
ADDIU SP, SP, 0xFFE8 /* Allocate stack, -24 */
SW RA, 0x14(SP) /* Store return address to stack */

LUI T3, 0x80D0
LB T3, 0x0000(T3)

BEQ T3, R0, DmaCopy
NOP
BNE T3, R0, Run
NOP

/* Copy our main code to extended RAM, 0x80C00000. */
DmaCopy:
LUI V0, 0x80C0
ORI A0, V0, 0x0000
LUI V0, 0x0120
ORI A1, V0, 0xFC00
JAL 0x00278504
ORI A2, V0, 0xFCD0

/* Store 1 to 0x80D00000. This prevents
 * DMACopy being looped endless times. */
LUI T2, 0x80D0
ADDIU T3, T3, 0x0001
SB T3, 0x0000(T2)
NOP

Run:
JAL 0x80C00000
NOP

Exit:
LW RA, 0x14(SP)
JR RA
ADDIU SP, SP, 0x18
